// Exp.java                                    MuP1 2014/15

/**
 * Exponentialfunktion f(x) = e^x,
 * Fortsetzungefehler bei Reihenentwicklungen.
 */
public class Exp
{  
/**
 * Berechnung von f(x) = e^x durch Reihenentwicklungen.
 */
  public static double myExp(double x)
  {
    double summand = 1.0, oldsum = 1.0, newsum = 1.0;
    int i = 1;
    do
    {
      summand *= x / (double) (i++);
      oldsum = newsum;
      newsum += summand;
    } while(oldsum != newsum);
    return oldsum;
  }
   
/**
 * Fehlerbehandlung fuer x < 0: f(x) = 1 / e^(-x).
 */
  public static double myExpBesser(double x)
  {
    if( x >= 0.0) return myExp(x);
    else return (1.0 / myExp(-x));
  }
   
/**
 * Testprogramm:
 * Tabelle im Bereich [ 0 , -20] mit der Schrittweite 0.5.
 */
  public static void main(String[] args)
  {
    for( double x = 0; x > -20; x -= .5)
    {
      System.out.println();
      System.out.println( "x = " + x);
      System.out.println( "Math.exp   : " + Math.exp( x));
      System.out.println( "myExp      : " + myExp( x));
//    System.out.println( "absoluter Fehler: " + Math.abs( myExp( x) - Math.exp( x)));
      System.out.println( "myExpbesser: " + myExpBesser(x));
//    System.out.println( "absolute Fehler: " + Math.abs(myExpBesser(x) - Math.exp(x)));
    }
  }
}