// Quer.java                                   MuP1 2014/15

import Tools.IO.*;

/**
 * Klasse Quer berechnet iterativ und rekursiv Quersummen.
 */
public class Quer
{  
/**
 * Rekursive Quersummen.
 * @param n natuerliche Zahl
 * @return Quersumme, rekursiv
 */
   public static int reQuer( long n)
   {
      int rest;
      
      if( n == 0) return 0;
      rest = (int)( n % 10);
      return rest + reQuer( n / 10);
   }
   
/**
 * Iterative Quersummen.
 * @param n natuerliche Zahl
 * @return Quersumme, iterativ
 */
   public static int itQuer( long n)
   {
      int rest, qsumme = 0;
      
      while( n > 0)
      {
         rest = (int)( n % 10);
         n /= 10;
         qsumme += rest;
      }
      return qsumme;
   }
   
/**
 * Iterative Quersummen,
 * gewichtet mit periodischer Folge 1, 3, 2, -1, -3, -2.
 * @param n natuerliche Zahl
 * @return Quersumme, iterativ gewichtet
 */
   public static int wQuer(long n)
   {
      int[] folge = { 1, 3, 2, -1, -3, -2 };
      int rest, i = 0, wsumme = 0;
      
      while(n > 0)
      {
         rest = (int)( n % 10);
         n /= 10;
         wsumme += rest * folge[ i % 6];
         i++;
      }
      return wsumme;
   }
   
/**
 * Testprogramm: Eingabe einer Zahl,
 * Berechnung und Ausgabe der Quersummen,
 * berechnet mit den unterschiedlichen Methoden.
 */
   public static void main(String[] args)
   {
      long n;
      char weiter;
      
      do
      {
        n = IOTools.readLong( "Zahl eingeben: ");
        System.out.println ( n);
        System.out.println
        ( "iterative Quersumme: " + itQuer( n));
        System.out.println
        ( "rekursive Quersumme: " + reQuer( n));
        System.out.println
        ( "gewichtete Quersumme: " + wQuer( n));

        weiter = IOTools.readChar( "Weiter(j/n)? ");
      }while( weiter == 'j');
   }
}